#!/usr/bin/python

import os;
import tempfile;


WORKDIR="/home/tst/pallas-listing/"

def smb_get_serverliste(server):
    try:
        f = os.popen("smbclient /// x -L"+server)
    except IOError:
        print ("IOError beim holen der Hostliste")
        exit(0)
        
    ausgabe = f.readlines()

    found = 0;
    serverliste=[]
        
    for s in ausgabe:
        if (found):
            temp = s.split()
            if (temp.count("Workgroup")): found=0
            elif (temp.count("---------")): pass
            elif (temp): serverliste.append(temp[0])
        else:
            if s.split() == ["Server", "Comment"]:
                found=1
    return serverliste;



def smb_get_shareliste(host):
    try:
        f = os.popen("smbclient /// \"\" -L"+host)
    except IOError:
        print ("IOError beim Holen der Shareliste von "+host)
        return 0;

    ausgabe = f.readlines()

    found = 0;
    shareliste=[]
        
    for s in ausgabe:
        if (found):
            temp = s.split()
            if (temp.count("Server")): found=0
            elif (temp.count("---------")): pass
            elif (temp):
                if ((temp[0].find("$")==-1) and (temp[1]=="Disk")): shareliste.append(temp[0])
        else:
            if s.split() == ["Sharename", "Type", "Comment"]:
                found=1
    return shareliste;


def smb_mount_share(host, share):
    os.chdir(WORKDIR)
    td=tempfile.mktemp(".d")
    print td
    os.mkdir(td)
    print "Fhre aus: smbmount //"+host+"/"+share+" "+td
    mount=os.popen("smbmount //"+host+"/"+share+" "+td+" -opassword=\"\"")
    print mount.readlines()
    mount.close()
    os.chdir(td)
    ls=os.popen("ls -lR")
    os.chdir(WORKDIR)
    of=open("listen/"+host+"_"+share,'w')
    for s in ls.readlines():
        of.write(s)
    ls.close()
    mount=os.popen("smbumount "+td)
    print mount.readlines()
    mount.close()
    os.rmdir(td)
    return 0


for host in smb_get_serverliste("MILA"):
    print "Host: "+host
    print "WD: "+os.getcwd()
    for share in smb_get_shareliste(host):
        print "---->Share: "+share
        smb_mount_share(host,share)
    
